[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Diff for /openbsd/update_openbsd/update_openbsd between version 1.23 and 1.106

version 1.23, 2009/05/15 00:00:46 version 1.106, 2017/12/11 03:12:34
Line 1 
Line 1 
 #!/bin/sh  #!/bin/sh
 # $RedRiver: update_openbsd,v 1.22 2009/05/13 16:40:50 andrew Exp $  # $AFresh1: update_openbsd,v 1.105 2017/12/11 02:58:57 andrew Exp $
   #
   # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   #
   
 installed_sets() {  installed_sets() {
     local misc=/usr/share/doc/README      local misc=/usr/share/doc/README
     local man=/usr/share/man/cat1/intro.0      local man=/usr/share/man/man1/intro.1
     local comp=/usr/bin/cc      local comp=/usr/bin/cc
     local game=/usr/games/      local game=/usr/games/
     local xbase=/usr/X11R6/      local xbase=/usr/X11R6/
Line 12 
Line 27 
     local xserv=/usr/X11R6/bin/X      local xserv=/usr/X11R6/bin/X
     local xshare=/usr/X11R6/bin/startx      local xshare=/usr/X11R6/bin/startx
   
       local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     local _c _d _e      local _c _d _e
     echo -n base      echo -n base
     echo -n ' etc'      [ $_nv -lt 57 ] && echo -n ' etc'
     for _d in misc man comp game xbase xetc xfont xserv xshare; do      for _d in misc man comp game xbase xetc xfont xserv xshare; do
           [ $_d = xetc -a $_nv -ge 57 ] && continue
         eval _e=\$${_d}          eval _e=\$${_d}
         _c=`ls $_e 2> /dev/null | wc -l`          _c=`ls $_e 2> /dev/null | wc -l`
         #echo $_c $_d $_e          #echo $_c $_d $_e
Line 24 
Line 41 
         fi          fi
     done      done
   
     sendmail -d0.1 root < /dev/null | grep -q SASL      sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL
     if [ $? == 0 ]; then      if [ $? == 0 ]; then
         echo -n ' sendmail-smtp_auth'          echo -n ' sendmail-smtp_auth'
     fi      fi
 }  }
   
   kernel_file_version() {
       echo exit | config -e $1 | grep -A1 ^OpenBSD
       #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
   }
   
   kernel_is_multiprocessor() {
       printf "find cpu*\nexit\n" | config -e $1 2>/dev/null | grep -q "cpu\* at "
   }
   
 version_in() {  version_in() {
         local _proto=${FTP%%://*}          local _proto=${FTP%%://*}
         local _file          local _file
Line 38 
Line 64 
             local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`              local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`
             _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`              _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`
   
         elif [ X"http" == X"${_proto}" ]; then          elif [ X"http" == X"${_proto}" -o X"https" == X"${_proto}" ]; then
             local _list=`${FTP_CMD} -V -o - ${FTP}/`              _file=`${FTP_CMD} -V -o - ${FTP}/index.txt |
             _file=`echo ${_list} | awk '/[^x]base[0-9][0-9]*\.tgz/ {                  sed -ne 's/.*\(base[0-9][0-9].tgz\).*/\1/p'`
                     sub("^.*base","base");  
                     sub("\.tgz.*",".tgz");  
                     print $0;  
                 }'`  
   
         elif [ X"scp" == X"${_proto}" ]; then          elif [ X"scp" == X"${_proto}" ]; then
             echo SCP is not yet supported >&2              echo SCP is not yet supported >&2
             return 2              return 2
   
         else          else
             echo Unsupported FTP ${FTP} >&2              echo Unsupported FTP ${FTP} >&2
             return 2              return 2
   
Line 61 
Line 83 
         echo $_v          echo $_v
 }  }
   
   set_boot_device() {
           BOOT_DEVICE=$( df -nP /bsd | sed -ne 's! .*/$!!p' )
   
           root_disk=$( echo $BOOT_DEVICE |
               sed -e 's,/dev/\([a-z]*[0-9]\)[a-z].*,\1,' )
           msdos_partition=$(
               fdisk $root_disk | grep -q '^*.*FAT32' \
               && \
               disklabel $root_disk | sed -ne 's/:.*MSDOS//p' | tr -d ' '
           )
   
           [ "$msdos_partition" ] &&
               BOOT_DEVICE="/dev/$root_disk$msdos_partition"
   }
   
   boot_device_mounted=""
   mount_boot_device() {
       [ "$boot_device_mounted" ] && return
   
       local default_mount=$( df -lnP /bsd | sed -ne 's!/dev/.* !!p' )
       local boot_mount=$( mount |
               sed -ne "s!^$BOOT_DEVICE on \([^ ]*\).*!\1!p" )
   
       if [ ! "$boot_mount" ]; then
           mount $BOOT_DEVICE /mnt
           boot_device_mounted=1
           KERNEL_ROOT=/mnt
       elif [ "$boot_mount" != "$default_mount" ]; then
           KERNEL_ROOT=$boot_mount/
       else
           KERNEL_ROOT=${default_mount%/}/
       fi
   }
   
   umount_boot_device() {
       [ "$boot_device_mounted" ] && umount $BOOT_DEVICE
       boot_device_mounted=""
   }
   
   find_boot_kernel() {
       local _k=$( ( \
           echo bsd; \
           [ -e boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
               s///; s/^.*://; s/ .*$//' boot.conf \
       ) | tail -1 )
       _k=$( follow_symlink $_k )
   
       local _d=$( dirname $_k )
       [ "$_d" = "." ] && _d=$PWD
   
       if [ $_d = . -o $_d = $PWD ]; then
           basename $_k
       else
           echo $_k
       fi
   }
   
 set_version() {  set_version() {
     CUR_VER=`uname -r`      CUR_VER=`uname -r`
     NEW_VER=`dc -e "$CUR_VER 0.1 + p"`      NEW_VER=`dc -e "$CUR_VER 0.1 + p"`
Line 96 
Line 175 
     fi      fi
   
     if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then      if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then
         if [ X"No" == X"${FORCE_DIR}" ]; then          if [ X"No" != X"${FORCE_DIR}" ]; then
             _dir=${NEW_VER}  
         else  
             _dir=${FORCE_DIR}              _dir=${FORCE_DIR}
           elif sysctl kern.version | grep -q -- '-current '; then
               _dir=snapshots
               FORCE_DIR=snapshots
           else
               _dir=${NEW_VER}
         fi          fi
         FTP=${MIRROR}/${_dir}/`machine`          FTP=${MIRROR}/${_dir}/`machine`
   
Line 120 
Line 202 
   
         if [ X"" == X"${_v}" ]; then          if [ X"" == X"${_v}" ]; then
             echo No sets in [${FTP}] >&2              echo No sets in [${FTP}] >&2
             return 2              return 2
         elif [ X"${_cv}" == X"${_v}" ]; then          elif [ X"${_cv}" == X"${_v}" ]; then
             NEW_VER=$CUR_VER              NEW_VER=$CUR_VER
         elif [ X"${_nv}" == X"${_v}" ]; then          elif [ X"${_nv}" == X"${_v}" ]; then
Line 137 
Line 219 
     fi      fi
   
     if [ X"" == X"${_v}" ]; then      if [ X"" == X"${_v}" ]; then
         echo ERROR: Unable to determine file version! >&2          if [ X"" == X"${MIRROR}" ]; then
               echo ERROR: No sets, and no MIRROR, unable to continue. >&2
           else
               echo ERROR: Unable to determine FILE_VER, check your MIRROR. >&2
           fi
         return 1          return 1
     fi      fi
   
Line 149 
Line 235 
     if [ X"" != X"${MIRROR}" ]; then      if [ X"" != X"${MIRROR}" ]; then
         FTP=${MIRROR}/${_dir}/`machine`          FTP=${MIRROR}/${_dir}/`machine`
     fi      fi
   
       KERNEL_ROOT=""
       [ -z "$BOOT_DEVICE" ] && set_boot_device
   
       mount_boot_device
       cd $KERNEL_ROOT
       BOOT_KERNEL=$( find_boot_kernel )
       BOOT_KERNEL_VERSION=$( kernel_file_version $BOOT_KERNEL )
       if [ $(sysctl -n hw.ncpufound) -gt 1 ] || kernel_is_multiprocessor $BOOT_KERNEL; then
           BOOT_KERNEL=bsd.mp
       fi
   
       BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
       NEW_KERNEL_VERSION=""
   
       # We want to default to what we had
       INSTALL_KERNELS="$BOOT_KERNEL"
       # if the boot kernel was our specially named bsd.sp, we install from bsd
       if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
           INSTALL_KERNELS="bsd"
       fi
   
       # We want to update all kernels that exist
       # either in the $KERNEL_ROOT or in /
       for b in bsd bsd.mp; do
           [ -e $b -o -e /$b ] || continue
           if [ X"${INSTALL_KERNELS% *}" != X"$b" ]; then
               INSTALL_KERNELS="$INSTALL_KERNELS $b"
           fi
       done
   
       cd $OLDPWD
       umount_boot_device
   
       BOOT_KERNELS=$INSTALL_KERNELS
       INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
 }  }
   
 get_sets() {  get_sets() {
     echo '### GETTING SETS ###'      echo '==> GETTING SETS'
     if [ X"" == X"$FTP" ]; then      if [ X"" == X"$FTP" ]; then
         echo ERROR: No FTP site set! >&2          echo ERROR: No FTP site set! >&2
         return 1          return 1
Line 163 
Line 285 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
     for _b in `echo /bsd* bsd bsd.mp bsd.rd | sort -u`; do      for _b in $INSTALL_KERNELS; do
         if [ -e /${_b} -a ! -e ./${_b} ]; then          if [ ! -e ./${_b} ]; then
             echo $FTP_CMD ${FTP}/${_b}              echo "===> $FTP_CMD ${FTP}/${_b}"
             $FTP_CMD ${FTP}/${_b}              $FTP_CMD ${FTP}/${_b}
           else
               echo "===> Have ${_b}"
         fi          fi
           kernel_file_version "${_b}"
     done      done
   
     for _s in $INSTALLED_SETS; do      for _s in $INSTALLED_SETS; do
           [ "$_v" -ge "57" -a "$_s" != "${_s%etc}" ] && continue
         local _file=${_s}${_v}.tgz          local _file=${_s}${_v}.tgz
         if [ ${_s} == sendmail-smtp_auth ]; then          if [ ${_s} == sendmail-smtp_auth ]; then
             _file=${_s}.gz              _file=${_s}.gz
         fi          fi
   
         if [ ! -e ./${_file} ]; then          if [ ! -e ./${_file} ]; then
             echo $FTP_CMD ${FTP}/${_file}              echo "===> $FTP_CMD ${FTP}/${_file}"
             $FTP_CMD ${FTP}/${_file}              $FTP_CMD ${FTP}/${_file}
         fi          fi
     done      done
   
     local _type      local _type
       local _ftp
     for _type in $CHECKSUM_TYPES; do      for _type in $CHECKSUM_TYPES; do
         if [ ! -e $_type ]; then          [ -e $_type ] && break
             echo $FTP_CMD ${FTP}/$_type          _ftp=`echo "$FTP" | sed -e 's,://[^/]*/,://ftp.openbsd.org/,'`
             $FTP_CMD ${FTP}/$_type          echo "===> $FTP_CMD ${_ftp}/$_type"
         fi          $FTP_CMD ${_ftp}/$_type
     done      done
 }  }
   
 follow_symlink () {  follow_symlink () {
     local _file=$1      local _file=$1
     local _next=$( file $_file |      # This could go circular, but I dunno how to fix that.
         grep 'symbolic link' |      if [ -h $_file ]; then
         sed -e s/^.*\\\`// -e s/\\\'\$// )          follow_symlink $( readlink -f $_file )
     if [ -h $_next ]; then  
         follow_symlink $_next  
     else      else
         echo $_next          echo $_file
     fi      fi
 }  }
   
 check_sum () {  check_sum () {
     local _type=$1      local _type=$1
     echo "### CHECKING $_type SUMS ###"      echo "==> CHECKING $_type SUMS"
     cd $RELEASEDIR      cd $RELEASEDIR
   
     if [ ! -e $_type ]; then      if [ ! -e $_type ]; then
Line 213 
Line 338 
         return 1          return 1
     fi      fi
   
     ls bsd* *gz | sed -e 's/\(.*\)/(\1)/' > index      local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     grep -f index $_type | sum -c      local _signify=`which signify 2>/dev/null`
       local _keyfile=/etc/signify/openbsd-${_nv}-base.pub
       local _b _s
   
       (
           for _b in $INSTALL_KERNELS; do echo "($_b)"        ; done
           for _s in $INSTALLED_SETS;  do echo "($_s$_nv.tgz)"; done
       ) > index
   
   
       if [ -n "$_signify" -a "$_type" != "${_type%.sig}" ]; then
           echo "===> Checking signature";
           if [ ! -e $_keyfile ]; then
               echo "key [$_keyfile] does not exist, cannot check $_type" >&2
               return 2
           fi
           signify -V -e -p $_keyfile -x $_type -m - | grep -f index | sha256 -c -
       else
          grep -f index $_type | sha256 -c
       fi
   
     if [ $? -ne 0 ]; then      if [ $? -ne 0 ]; then
         echo ERROR: $_type does not match! >&2          echo ERROR: $_type does not match! >&2
         return 1          return 1
Line 223 
Line 367 
 }  }
   
 check_sets() {  check_sets() {
     echo '### CHECKING SETS ###'      echo '==> CHECKING SETS'
     cd $RELEASEDIR      cd $RELEASEDIR
   
     local _missing_sets      local _missing_sets
     local _v=$FILE_VER      local _v=$FILE_VER
   
     for _b in `echo /bsd* bsd bsd.mp bsd.rd | sort -u`; do      mount_boot_device
         _b=${_b#/}      for _n in $INSTALL_KERNELS; do
         local _n=$_b          local _o=$_n
         if [ X"bsd.sp" == X"${_n}" ]; then          [ X"bsd" == X"${_o}" -a -e ${KERNEL_ROOT}bsd.sp ] && _o=bsd.sp
             _n=bsd          if [ -e ${KERNEL_ROOT}${_o} -a ! -e ./${_n} ]; then
         fi              echo ${_o} does not exist on $BOOT_DEVICE
         if [ -e /${_b} -a ! -e ./${_n} ]; then  
             echo ${_n} does not exist  
             _missing_sets=1              _missing_sets=1
         fi          fi
   
           if [ X"${BOOT_KERNEL}" == X"${_o}" -a -e ./${_n} ]; then
               NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
           fi
     done      done
       umount_boot_device
   
       if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
           echo Missing replacement for boot kernel $BOOT_KERNEL >&2
           _missing_sets=1
       fi
   
     for _s in $INSTALLED_SETS; do      for _s in $INSTALLED_SETS; do
           [ "$_v" -ge "57" -a "$_s" != "${_s%etc}" ] && continue
         local _file=${_s}${_v}.tgz          local _file=${_s}${_v}.tgz
         if [ ${_s} == sendmail-smtp_auth ]; then          if [ ${_s} == sendmail-smtp_auth ]; then
             _file=${_s}.gz              _file=${_s}.gz
Line 253 
Line 406 
     done      done
   
     if [ X"" == X"${_missing_sets}" ]; then      if [ X"" == X"${_missing_sets}" ]; then
         echo All OK          echo 'All OK'
     fi      fi
   
     local _type      local _type
     for _type in $CHECKSUM_TYPES; do      for _type in $CHECKSUM_TYPES; do
           [ -n "$NO_SIGNIFY" -a "$_type" != "${_type%.sig}" ] && continue
         if [ -e $_type ]; then          if [ -e $_type ]; then
             check_sum $_type              check_sum $_type && break
               [ -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1
         fi          fi
     done      done
   
       return 0
 }  }
   
   
 install_kernel() {  install_kernels() {
     echo '### INSTALLING KERNEL ###'      local _d=$1
     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then      local default_mount
         echo ${0##*/} must be run as root or SUDO must be set! >&2      local boot_mount
         exit 1      local mount_is_msdos
     fi  
   
     if [ X"" == X"$RELEASEDIR" ]; then      if [ ! "$_d" ]; then
         echo ERROR: no source for new kernels! >&2          default_mount=$( df -lnP /bsd | sed -ne 's!/dev/.* !!p' )
         exit 1          mount_boot_device
     else  
         cd $RELEASEDIR  
     fi  
   
     if [ ! -e bsd ]; then          if [ "$KERNEL_ROOT" != "$default_mount" ]; then
         echo ERROR: new bsd kernel does not exist! >&2                  local _ik="$INSTALL_KERNELS"
         exit 1                  INSTALL_KERNELS="$BOOT_KERNEL bsd.rd"
     fi  
   
     if [ -e /bsd.mp -a ! -e bsd.mp ]; then                  install_kernels $KERNEL_ROOT
         echo ERROR: new bsd.mp kernel does not exist! >&2  
         exit 1  
     fi  
   
     if [ ! -e bsd.rd ]; then                  INSTALL_KERNELS="$_ik"
         echo ERROR: new bsd.rd kernel does not exist! >&2          fi
         exit 1  
           umount_boot_device
   
           install_kernels $default_mount
           return
     fi      fi
   
     local _v=$FILE_VER      echo "==> INSTALLING KERNEL to $_d"
   
     $SUDO rm -f /obsd      if [ X"" == X"$RELEASEDIR" ]; then
     $SUDO ln /bsd /obsd          echo ERROR: no source for new kernels! >&2
     if [ $? -ne 0 ]; then  
         echo "Error copying old kernel!" >&2  
         exit 1          exit 1
     fi      fi
   
     local _true_bsd=`follow_symlink /bsd`      [ $_d != / ] && mount | grep -q " on ${_d%/} .* msdos" && mount_is_msdos=1
     local _installed_new_bsd  
   
     for _b in bsd*; do      if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
         $SUDO rm -f /nbsd          echo "===> Backing up $BOOT_KERNEL to ${_d}obsd"
         if [ X"${_b}" == X"bsd" ]; then          if [ $mount_is_msdos ]; then
             echo Copying bsd to /bsd.sp              cp $BOOT_KERNEL ${_d}obsd
             $SUDO cp bsd /nbsd && $SUDO mv /nbsd /bsd.sp  
             if [ $? -ne 0 ]; then  
                 echo ERROR: Could not copy new SP kernel! >&2  
                 exit 1  
             fi  
             if [ X"${_true_bsd}" == X"bsd" ]; then  
                 _installed_new_bsd=1  
             fi  
         else          else
             if [ -e /$_b ]; then              ln -f $BOOT_KERNEL ${_d}obsd
                 echo Copying $_b to /  
                 $SUDO cp ${_b} /nbsd && $SUDO mv /nbsd /${_b}  
                 if [ $? -ne 0 ]; then  
                     echo ERROR: Could not copy new $_b kernel! >&2  
                     exit 1  
                 fi  
                 if [ X"${_true_bsd}" == X"${_b}" ]; then  
                     _installed_new_bsd=1  
                 fi  
             fi  
         fi          fi
     done  
   
     if [ ! -h /bsd ]; then  
         if [ -e /bsd.mp ]; then  
             echo linking /bsd.mp to /bsd  
             $SUDO ln -sf /bsd.mp /bsd  
         else  
             echo linking /bsd.sp to /bsd  
             $SUDO ln -sf /bsd.sp /bsd  
         fi  
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo ERROR: Could not symlink new kernel! >&2              echo "Error copying old kernel!" >&2
             exit 1              exit 1
         fi          fi
     fi      fi
   
     if [ -z $_installed_new_bsd ]; then      cd $RELEASEDIR
         echo WARNING: Did not replace $_true_bsd kernel >&2  
       for _b in $INSTALL_KERNELS; do
           rm -f ${_d}nbsd
           local _bd=$_b
           [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
   
           local _is_boot=""
           [ X"$BOOT_KERNEL" == X"${_d}${_bd}" ] && _is_boot="# boot kernel"
   
           echo "Copying $_b to ${_d}$_bd $_is_boot"
           cp ${_b} ${_d}nbsd && mv ${_d}nbsd ${_d}${_bd}
           if [ $? -ne 0 ]; then
               echo ERROR: Could not copy new $_bd kernel! >&2
               exit 1
           fi
       done
   
       cd $OLDPWD
   
       if [ ! -h ${_d}bsd ]; then
           cd ${_d}
           for _b in $BOOT_KERNELS; do
               [ X"$_b" == X"bsd" ] && _b="bsd.sp"
               if [ -e $_b ]; then
                   if [ "$mount_is_msdos" ]; then
                       echo "===> Moving $_b ${_d}bsd (MSDOS)"
                       mv -f ${_b} bsd
                   else
                       echo "===> symlinking $_b to ${_d}bsd"
                       ln -sf $_b bsd
                   fi
                   break
               fi
           done
           cd $OLDPWD
     fi      fi
 }  }
   
 install_sets() {  install_sets() {
     echo '### INSTALLING SETS ###'      echo '==> INSTALLING SETS'
     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then  
         echo ${0##*/} must be run as root or SUDO must be set! >&2  
         exit 1  
     fi  
   
     if [ X"" == X"$RELEASEDIR" ]; then      if [ X"" == X"$RELEASEDIR" ]; then
         echo ERROR: no source for sets! >&2          echo ERROR: no source for sets! >&2
Line 368 
Line 520 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
     if [ $CUR_VER != $NEW_VER -a ! -e /sbin/oreboot ]; then  
         $SUDO cp /sbin/reboot /sbin/oreboot  
         if [ $? -ne 0 ]; then  
             echo "Error copying old reboot command!" >&2  
             exit 1  
         fi  
         echo "/sbin/reboot copied to /sbin/oreboot"  
     fi  
   
     local _sets=`ls *${_v}.tgz | grep -v ^base `      local _sets=`ls *${_v}.tgz | grep -v ^base `
     for _f in ${_sets} base${_v}.tgz; do      for _f in ${_sets} base${_v}.tgz; do
         _path=$DESTDIR          _path=$DESTDIR
Line 386 
Line 529 
             _path=/var/tmp/temproot              _path=/var/tmp/temproot
         fi          fi
   
         echo Extracting $_f to $_path          echo "Extracting $_f to $_path"
         $SUDO mkdir -p $_path          mkdir -p $_path
         $SUDO tar -C $_path -xzphf ${RELEASEDIR}/${_f}          tar -C $_path -xzphf ${RELEASEDIR}/${_f}
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo ERROR: Could not extract ${_f}! >&2              echo ERROR: Could not extract ${_f}! >&2
             exit 1              exit 1
         fi          fi
     done      done
   
     echo Extracted all sets.      echo '===> Extracted all sets.'
   }
   
   install_sendmail_smtp_auth() {
     if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then      if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then
         gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \          gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \
             ${RELEASEDIR}/sendmail-smtp_auth              ${RELEASEDIR}/sendmail-smtp_auth
     fi      fi
     if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then      if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then
         if ! pkg_info -qe 'cyrus-sasl-*'; then          if ! pkg_info -qe 'cyrus-sasl-*'; then
             $SUDO pkg_add -i cyrus-sasl              pkg_add -i cyrus-sasl
         fi          fi
   
         $SUDO install -o root -g smmsp -m 2555 \          install -o root -g smmsp -m 2555 \
             ${RELEASEDIR}/sendmail-smtp_auth \              ${RELEASEDIR}/sendmail-smtp_auth \
             /usr/libexec/sendmail/sendmail              /usr/libexec/sendmail/sendmail
   
         echo Installed sendmail with smtp_auth          echo '===> Installed sendmail with smtp_auth'
     fi      fi
 }  }
   
 update_etc() {  update_etc() {
     echo '### UPDATING ETC ###'      echo '==> UPDATING ETC'
     if [ ! -e $SYSMERGE ]; then      if [ ! -e $SYSMERGE ]; then
         SYSMERGE=          echo "ERROR: Can't find sysmerge!" >&2
           exit 1;
     fi      fi
   
     if [ X"" == X"$SYSMERGE" ]; then      local _v=$FILE_VER
         if [ -e /var/tmp/temproot ]; then      local _args=""
             MERGEMASTER=`which mergemaster`  
   
             if [ $? != 0 ]; then      if [ ! -e /var/sysmerge/etc.tgz ]; then
                 $SUDO pkg_add -i mergemaster  
   
                 MERGEMASTER=`which mergemaster`  
                 if [ $? != 0 ]; then  
                     echo ERROR: mergemaster not installed! >&2  
                     exit 1  
                 fi  
             fi  
   
             echo '### RUNNING MERGEMASTER ###'  
             $SUDO $MERGEMASTER -irv  
         else  
             echo "ERROR: no source for etc!" >&2  
             exit 1  
         fi  
     else  
         if [ X"" == X"$RELEASEDIR" ]; then          if [ X"" == X"$RELEASEDIR" ]; then
             echo "ERROR: no source for etc!" >&2              echo "ERROR: no source for etc!" >&2
             exit 1              exit 1
         else  
             cd $RELEASEDIR  
         fi          fi
   
         local _v=$FILE_VER          cd $RELEASEDIR
   
         if [ -e etc${_v}.tgz ]; then          if [ -e etc${_v}.tgz ]; then
             _args="$_args -s etc${_v}.tgz"              _args="$_args -s ${RELEASEDIR}/etc${_v}.tgz"
         fi          fi
         if [ -e xetc${_v}.tgz ]; then          if [ -e xetc${_v}.tgz ]; then
             _args="$_args -x xetc${_v}.tgz"              _args="$_args -x ${RELEASEDIR}/xetc${_v}.tgz"
         fi          fi
         if [ X"" == X"$_args" ]; then          if [ X"" == X"$_args" ]; then
             echo ERROR: No upgrade sets found! >&2              echo ERROR: No upgrade sets found! >&2
         else              exit 1
             echo '### RUNNING SYSMERGE ###'  
             _args="-a $_args"  
             $SUDO $SYSMERGE $_args  
         fi          fi
     fi      fi
   
       echo '==> RUNNING SYSMERGE'
       $SYSMERGE $_args
   
       cd $OLDPWD
 }  }
   
   
   if [ $(id -u) != 0 ]; then
       echo 'ERROR: need root privileges to run this script' >&2
       exit 1
   fi
   
 if [ -e /etc/update_openbsd.conf ]; then  if [ -e /etc/update_openbsd.conf ]; then
     . /etc/update_openbsd.conf      . /etc/update_openbsd.conf
 fi  fi
Line 474 
Line 609 
     . ${HOME}/.update_openbsdrc      . ${HOME}/.update_openbsdrc
 fi  fi
   
 #MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}  MIRROR=${MIRROR:=http://fastly.cdn.openbsd.org/pub/OpenBSD}
 FTP_CMD=${FTP_CMD:=ftp -V}  FTP_CMD=${FTP_CMD:=ftp -V}
 PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}  
   
 DESTDIR=${DESTDIR:=/}  DESTDIR=${DESTDIR:=/}
 SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}  SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}
 FORCE_DIR=${FORCE_DIR:=No}  FORCE_DIR=${FORCE_DIR:=No}
   
   export PKG_PATH TRUSTED_PKG_PATH
   
   set_version
   
   TRUSTED_PKG_PATH=${TRUSTED_PKG_PATH:=/usr/ports/packages/`machine -a`/all}
   if [ "$FORCE_DIR" = "No" ]; then
           PKG_PATH=${PKG_PATH:=${MIRROR}/$NEW_VER/packages/`machine -a`}
   else
           PKG_PATH=${PKG_PATH:=${MIRROR}/$FORCE_DIR/packages/`machine -a`}
   fi
   
 INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}  INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
   
 CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256 MD5}  CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256.sig SHA256}
   
 set_version  
 local _error=$?  local _error=$?
   
 echo  echo
 echo "-= update_openbsd - helper script to update OpenBSD =-"  echo "-= update_openbsd - helper script to update OpenBSD =-"
 echo "------------------------------------------------------"  echo "------------------------------------------------------"
 echo  echo
 echo "          SUDO: $SUDO"  echo "        SYSMERGE: $SYSMERGE"
 echo "      SYSMERGE: $SYSMERGE"  echo "          MIRROR: $FTP"
 echo "        MIRROR: $MIRROR"  echo "        PKG_PATH: $PKG_PATH"
 echo "    RELEASEDIR: $RELEASEDIR"  echo "TRUSTED_PKG_PATH: $TRUSTED_PKG_PATH"
 echo "       DESTDIR: $DESTDIR"  echo "      RELEASEDIR: $RELEASEDIR"
 echo "INSTALLED_SETS: $INSTALLED_SETS"  echo "         DESTDIR: $DESTDIR"
   echo "     BOOT_DEVICE: $BOOT_DEVICE"
   echo "     BOOT_KERNEL: $BOOT_KERNEL"
   echo " INSTALL_KERNELS: $INSTALL_KERNELS"
   echo "  INSTALLED_SETS: $INSTALLED_SETS"
 echo  echo
 echo "       CUR_VER: $CUR_VER"  echo "         CUR_VER: $CUR_VER"
 echo "       NEW_VER: $NEW_VER"  echo "         NEW_VER: $NEW_VER"
 #echo "      FILE_VER: $FILE_VER"  #echo "        FILE_VER: $FILE_VER"
 echo  echo
   
   mount_boot_device
   for k in $INSTALL_KERNELS; do
       if [ -e $KERNEL_ROOT$k ]; then
           echo "Existing $BOOT_DEVICE:$k"
           kernel_file_version $KERNEL_ROOT$k
       fi
   done
   umount_boot_device
   
 if [ ${_error} -ne 0 ]; then  if [ ${_error} -ne 0 ]; then
         exit ${_error}          exit ${_error}
 fi  fi
Line 515 
Line 672 
   
 check_sets || exit  check_sets || exit
   
 if [ X"" != X"$SUDO" ]; then  echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"
     echo Please enter your sudo password if prompted.  if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
     echo You may be asked for it again later in the process.    -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
     $SUDO -v      echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"
 fi  fi
   if [ -n "$NEW_KERNEL_VERSION" ]; then
       echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
   else
       echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2
       echo "ctrl+C to cancel, enter to continue anyway" >&2
       local _temp
       read _temp
       NEW_KERNEL_VERSION=$BOOT_KERNEL_VERSION
   fi
   
 install_kernel  if [ X"$NEW_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" ]; then
       echo >&2
       echo "!!!  You are upgrading the OpenBSD kernel.        !!!" >&2
       echo "!!!  You will be given the opportunity to reboot  !!!" >&2
       echo "!!!  at the end of the proces but it is safer to  !!!" >&2
       echo "!!!  have a separate root shell open.             !!!" >&2
       echo "!!!  It is needed in order to run /sbin/oreboot.  !!!" >&2
       echo "!!!  doas MAY NOT WORK after sets are extracted.  !!!" >&2
       echo >&2
       echo "enter to continue, ctrl+C to cancel" >&2
       local _temp
       read _temp
   
       if [ ! -e /sbin/oreboot ]; then
           cp /sbin/reboot /sbin/oreboot
           if [ $? -ne 0 ]; then
               echo "Error copying old reboot command!" >&2
               exit 1
           fi
           echo "/sbin/reboot copied to /sbin/oreboot"
       fi
   fi
   
   install_kernels
 install_sets  install_sets
   
 if [ $CUR_VER == $NEW_VER ]; then  if [ X"$NEW_KERNEL_VERSION" == X"$BOOTED_KERNEL_VERSION" ]; then
       install_sendmail_smtp_auth
   
     if [ -e /sbin/oreboot ]; then      if [ -e /sbin/oreboot ]; then
         echo Removing /sbin/oreboot          echo Removing /sbin/oreboot
         $SUDO rm -f /sbin/oreboot          rm -f /sbin/oreboot
     fi      fi
     update_etc      update_etc
   
     echo '### UPDATING PACKAGES ###'      OPENUP=$( which openup 2>/dev/null )
     $SUDO pkg_add -ui -F update -F updatedepends      if [ -n "$OPENUP" ]; then
           echo "==> UPDATING WITH $OPENUP"
           $OPENUP
       else
           echo '==> UPDATING PACKAGES'
           pkg_add -u
       fi
   
       echo '==> UPDATING FIRMWARE'
       fw_update
   
 else  else
     echo Instructions for updating to the new version available from      [ -e /etc/rc.sysmerge ] && grep -q $SYSMERGE /etc/rc.sysmerge ||
     echo "  http://www.openbsd.org/faq/upgrade${_v}.html"          echo "$SYSMERGE -b" >>/etc/rc.sysmerge &&
           echo "==> RUNNING $SYSMERGE -b ON REBOOT"
   
       echo Instructions for updating to the new version available from
       if [ X"snapshots" == X"$FORCE_DIR" ]; then
           echo "  http://www.openbsd.org/faq/current.html"
       else
           echo "  http://www.openbsd.org/faq/upgrade${FILE_VER}.html"
       fi
 fi  fi
   
 echo New kernel installed.  Please reboot!  echo Update complete. enter to reboot, ctrl+C to cancel
   read _temp
 if [ -e /sbin/oreboot ]; then  if [ -e /sbin/oreboot ]; then
     echo Possibly using /sbin/oreboot      echo using /sbin/oreboot
       /sbin/oreboot
   else
       /sbin/reboot
 fi  fi

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.106

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>